"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const cli_ux_1 = __importDefault(require("cli-ux"));
const base58 = __importStar(require("@mesg/api/lib/util/base58"));
const root_command_1 = __importDefault(require("../../root-command"));
class ProcessDelete extends root_command_1.default {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const { argv, flags } = this.parse(ProcessDelete);
            if (!flags.confirm && !(yield cli_ux_1.default.confirm('Are you sure?')))
                return [];
            this.spinner.start('Deleting process(s)');
            for (const hash of argv) {
                this.spinner.status = hash;
                yield this.api.process.delete({ hash: base58.decode(hash) });
            }
            this.spinner.stop();
            return argv;
        });
    }
}
exports.default = ProcessDelete;
ProcessDelete.description = 'Delete one or many processes';
ProcessDelete.flags = Object.assign(Object.assign({}, root_command_1.default.flags), { confirm: command_1.flags.boolean({ description: 'Confirm deletion', default: false }) });
ProcessDelete.strict = false;
ProcessDelete.args = [{
        name: 'PROCESS_HASH...',
        required: true,
    }];
