"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const base58 = __importStar(require("@mesg/api/lib/util/base58"));
const root_command_1 = __importDefault(require("../../root-command"));
const start_1 = __importDefault(require("./start"));
class ServiceCreate extends root_command_1.default {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const { args, flags } = this.parse(ServiceCreate);
            this.spinner.start('Create service');
            const service = JSON.parse(args.DEFINITION);
            const resp = yield this.api.service.create(service);
            if (!resp.hash)
                throw new Error('invalid hash');
            this.spinner.stop(base58.encode(resp.hash));
            if (flags.start) {
                this.spinner.start('Starting service');
                const start = yield start_1.default.run([base58.encode(resp.hash), ...this.flagsAsArgs(flags)]);
                this.spinner.stop(base58.encode(start.hash));
            }
            return { hash: resp.hash };
        });
    }
}
exports.default = ServiceCreate;
ServiceCreate.description = 'Create a service';
ServiceCreate.flags = Object.assign(Object.assign({}, root_command_1.default.flags), { start: command_1.flags.boolean({
        description: 'Automatically start the service once created',
        default: false,
    }) });
ServiceCreate.args = [{
        name: 'DEFINITION',
        required: true,
        description: 'Service\'s definition. Use service:compile first to build service definition'
    }];
