"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const root_command_1 = __importDefault(require("../../root-command"));
const resolver_1 = require("../../utils/resolver");
class ServiceDetail extends root_command_1.default {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const { args } = this.parse(ServiceDetail);
            const hash = yield resolver_1.serviceResolver(this.api, args.SERVICE_HASH);
            const response = yield this.api.service.get({ hash });
            this.styledJSON(response);
            return response;
        });
    }
}
exports.default = ServiceDetail;
ServiceDetail.description = 'Display detailed information on a service';
ServiceDetail.flags = Object.assign({}, root_command_1.default.flags);
ServiceDetail.args = [{
        name: 'SERVICE_HASH',
        required: true
    }];
