"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const cli_ux_1 = __importDefault(require("cli-ux"));
const base58 = __importStar(require("@mesg/api/lib/util/base58"));
const root_command_1 = __importDefault(require("../../root-command"));
class ServiceList extends root_command_1.default {
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const { flags } = this.parse(ServiceList);
            const [{ services }, { instances }, { runners }] = yield Promise.all([
                this.api.service.list({}),
                this.api.instance.list({}),
                this.api.runner.list({}),
            ]);
            cli_ux_1.default.table(services || [], {
                hash: { header: 'HASH', get: srv => base58.encode(srv.hash) },
                sid: { header: 'SID', get: srv => srv.sid },
                instances: {
                    header: 'INSTANCES',
                    get: srv => (instances || [])
                        .filter(inst => inst.serviceHash.toString() === srv.hash.toString())
                        .map(inst => [
                        base58.encode(inst.hash),
                        (runners || [])
                            .filter(run => run.instanceHash.toString() === inst.hash.toString())
                            .reduce((p, _, i) => p + (i > 0 ? '\n' : ''), '')
                    ].join(''))
                        .join('\n'),
                },
                runners: {
                    header: 'RUNNERS',
                    get: srv => (instances || [])
                        .filter(inst => inst.serviceHash.toString() === srv.hash.toString())
                        .map(inst => (runners || [])
                        .filter(run => run.instanceHash.toString() === inst.hash.toString())
                        .map(run => base58.encode(run.hash))
                        .join('\n'))
                        .join('\n'),
                }
            }, Object.assign({ printLine: this.log }, flags));
            return instances || [];
        });
    }
}
exports.default = ServiceList;
ServiceList.description = 'List running services';
ServiceList.flags = Object.assign(Object.assign({}, root_command_1.default.flags), cli_ux_1.default.table.flags());
