/// <reference types="node" />
import { flags } from '@oclif/command';
import { IEvent } from '@mesg/api/lib/event';
import { IExecution } from '@mesg/api/lib/execution';
import Command from '../../root-command';
export interface Log {
    dependency: string;
    data: Buffer;
}
export default class ServiceLogs extends Command {
    static description: string;
    static flags: {
        events: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        results: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        event: flags.IOptionFlag<string>;
        task: flags.IOptionFlag<string>;
        tail: import("@oclif/parser/lib/flags").IOptionFlag<number>;
        follow: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        help: import("@oclif/parser/lib/flags").IBooleanFlag<void>;
        quiet: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        silent: import("@oclif/parser/lib/flags").IBooleanFlag<boolean>;
        port: import("@oclif/parser/lib/flags").IOptionFlag<number>;
        host: flags.IOptionFlag<string>;
    };
    static args: {
        name: string;
        required: boolean;
    }[];
    private readonly docker;
    run(): Promise<{
        destroy: () => void;
    }>;
    formatEvent(event: IEvent): string;
    formatResult(execution: IExecution): string;
}
