"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const base58 = __importStar(require("@mesg/api/lib/util/base58"));
const resolve_1 = require("@mesg/api/lib/util/resolve");
exports.serviceResolver = (api, sidOrHash) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        let hash;
        if (sidOrHash instanceof Uint8Array) {
            hash = sidOrHash;
        }
        else {
            hash = base58.decode(sidOrHash);
        }
        yield api.service.get({ hash });
        return hash;
    }
    catch (_a) {
        const { services } = yield api.service.list({});
        const match = (services || []).filter(x => x.sid === sidOrHash);
        if (match.length === 0)
            throw new Error(`no service matching ${sidOrHash}`);
        if (match.length > 1)
            throw new Error(`multiple services matching ${sidOrHash}`);
        return match[0].hash;
    }
});
exports.instanceResolver = (api, sidOrHash) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        let hash;
        if (sidOrHash instanceof Uint8Array) {
            hash = sidOrHash;
        }
        else {
            hash = base58.decode(sidOrHash);
        }
        yield api.instance.get({ hash });
        return hash;
    }
    catch (err) {
        if (typeof sidOrHash === 'string') {
            return resolve_1.resolveSID(api, sidOrHash);
        }
        throw err;
    }
});
exports.runnerResolver = (api, sidOrHash) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        let hash;
        if (sidOrHash instanceof Uint8Array) {
            hash = sidOrHash;
        }
        else {
            hash = base58.decode(sidOrHash);
        }
        yield api.runner.get({ hash });
        return hash;
    }
    catch (err) {
        if (typeof sidOrHash === 'string') {
            return resolve_1.resolveSIDRunner(api, sidOrHash);
        }
        throw err;
    }
});
